      program dnff

      use iounits_inc
      use params1_inc
      use decimate_inc
      use input_inc


      character*10 cdate
      character*4 cvers
      parameter (cvers = '4.2.1', cdate = '2014-08-13')   !BRL modifications
      
      !BRL: mods made to run under Intel Fortran under windows. Most modified lines are annotated with BRL
      !numerous ambiguities and mistakes were corrected so that the code was accepted by the Intel
      !Fortran compiler which is much fussier than the Linux verion. I did not use any options such as
      !F77 compatibility, so hopefully this version will be more portable. The exception is SUN OS fortran
      !where the 'endian' order is not reversed.
      !The worst mistake was the direct access write to the f4 output file exceeding the record length of 20 bytes
      !for 4 channels (it should be 36 bytes) which corrupted the header record (and other records as well).
      !Complex numbers had been assumed to have the same length as reals (4 bytes single precision) whereas they 
      !of course require two reals on ANY machine and in any mathematical system, on this planet at least. 
  
!      include 'iounits.inc'
!      include 'params1.inc'
!      include 'decimate.inc'
!      include 'input.inc'c

!      parameter (nt=nwmx/2,ntot= nwmx*nchmx,nchmx1=nchmx+1,
!     &  nmax = 4*nwmx,nwsvmx = nwmx*4+15,nfmax=nwmx/2,nwmx1=nwmx+10
!     &       , nchmx2 = 2*nchmx,nchmx21 = nchmx*2+1)
      parameter (nt=nwmx/2,ntot= nwmx*nchmx,nchmx1=nchmx+1,
     &  nmax = 4*nwmx,nwsvmx = nwmx*4+15,nfmax=nwmx/2,nwmx1=nwmx+40
     &       , nchmx2 = 2*nchmx,nchmx21 = nchmx*2+1)
          
      real x(nchmx,nwmx1),samprate(ndmx),w(nwmx,ndmx)
     &    ,sc(nchmx),wsave(nwsvmx,ndmx),stcor(2),orient(2,nchmx),
     &    xx(ndmx,nchmx1,0:nmax),pspecl1(nchmx,nwmx,ndmx),
     &    areg(nchmx,10),rr(nwmx),ar(nwmx),bwo(nwmx),br(nwmx,1)
      real	dt
	integer nsave(15,ndmx)            ! TH: work array used for ifac in cfft
!TH      complex wrk(nwmx),rnrmt(nchmx,ndmx,nt),cwrk(nchmx,nsmax)
      
      complex, ALLOCATABLE, DIMENSION(:,:,:), SAVE :: rnrmt
      complex, ALLOCATABLE, DIMENSION(:,:), SAVE :: cwrk
      complex, ALLOCATABLE, DIMENSION(:,:), SAVE :: cout
!      (nchmx,ndmx,nt),cwrk(nchmx,nsmax)
!     &   ,cout(nchmx,nsmax)
      !commenting this out meant wrk was not dimensioned at all - BRL
      real wrk(2,nwmx)       ! TH in subroutin fft 
      
      real, ALLOCATABLE, DIMENSION(:,:), SAVE :: x1
      real, ALLOCATABLE, DIMENSION(:,:,:), SAVE :: x_scr
      integer, ALLOCATABLE, DIMENSION(:,:), SAVE :: ix1
!      real x1(nchmx1,nmax)  
!      integer ix1(nchmx1,nmax),
!     & 
      integer, ALLOCATABLE, DIMENSION(:,:), SAVE :: iwrk, ifdir, iset 
      integer, ALLOCATABLE, DIMENSION(:), SAVE :: ixs
      integer next(ndmx),ifirstd(ndmx),nacc(ndmx),
     &    idp(0:ndmx,2,nbadmx),
     &    ids(0:ndmx,2,nbadmx),ndp(0:ndmx),ifirst(ndmx),nspec(ndmx)
     4   ,nds(0:ndmx),iftype(nfilmax,nchmx),
     5    nfil(nchmx) 
     6    ,idl(ndmx)
      integer iset_offset(ndmx), irlo

        logical lstart(ndmx),lstartd(ndmx),lgood,lg,lclkd
     &  ,lfd(nchmx,ndmx),lwinst(ndmx),lend
        
	logical l_real,l_SP,l_proc, l_recfil
      character*1 ans
      character*50 arg,cstring
      character*6 chid(nchmx)
      character*256 afparam(nfilmax,nchmx)

C   SCRATCH FILE 02.01.98
!      real x_scr(nsmax*nfmax,nchmx,2)
      integer iuse_scr(nsmax*nfmax)
      allocate(rnrmt(nchmx,ndmx,nt))
      allocate(cwrk(nchmx,nsmax))
      allocate(cout(nchmx,nsmax))
      allocate(x1(nchmx1,nmax))  
      allocate(ix1(nchmx1,nmax))
      allocate(iwrk(nchmx,nsmax))
      allocate(iset(4,nsmax))
      allocate(ifdir(3,nsmax))
      allocate(ixs(nsmax))
      allocate(x_scr(nsmax*nfmax,nchmx,2))
      

       print*,'********************************************************'
       print*,'*                                                      *'
       print*,'*   KMS_DNFF   Version: ',cvers,'   Date: ',cdate,
     &'        *'
       print*,'*                                                      *'
       print*,'********************************************************'
       print*,' '
       bytes = NBYTES
       l_asc = (BINASC .eq. 'ASC')
       !need to set these here if not using command line BS
       l_clk_hd = .false.
       l_NIMS = .false.
       l_flinp = .false.
       ierr_bin_read = 0
       l_real = .true.     ! flag for real numbers
       l_SP   = .true.        !read system param file
       l_proc = .true. !enable notch
       l_recfil = .false.  ! .false. = lockin filter, .true.= rec. notch
	   filtfreq = 60.      ! default for Notch filtering
 
ceg    ioff = 0
ccc      (ioff is offset to add to sample numbers returned by reading
ccc       routine;  this is set in bdrcsu)

c     parse command line options
      nargs = iargc()
      do k = 1, nargs
         call getarg(k,arg)
         if (arg(1:2) .eq. '-b') then
            read (arg(3:3),*) bytes
            
         elseif(arg(1:3) .eq. '-f:') then
            l_flinp = .true.
            flnam = arg(4:50)
            flnam = adjustl(flnam)
            flnam = trim(flnam)
               
         elseif(arg(1:2) .eq. '-a') then
ccc         ascii data file, read clock reset info from .clk file
            l_asc = .true.
         elseif(arg(1:2) .eq. '-A') then
ccc         ascii data file, read clock reset info from header of data file
            l_asc = .true.
            l_clk_hd = .true.
         elseif(arg(1:2) .eq. '-N') then
ccc         NIMS ascii data file, read clock reset info from header of data file
            l_asc = .true.
            l_NIMS = .true.
            l_clk_hd = .true.
	      l_real = .false.     ! read real numbers
         elseif(arg(1:2) .eq. '-B') then!
ccc         NIMS binary data file, read clock reset info from header of data file
            l_asc = .false.
            l_NIMS = .true.
	      l_real = .false.     ! read real numbers
         elseif(arg(1:3) .eq. '-KA') then
!TH         KMS ascii file with real numbers
            l_asc = .true.            
            l_clk_hd = .true.       ! clk header in file
	      l_real = .true.     ! read real numbers
         elseif(arg(1:3) .eq. '-ka') then
!TH         KMS ascii file with real numbers
            l_asc = .true.            
            l_clk_hd = .false.       ! clk header in external clk-file
	      l_real = .true.     ! read ascii real numbers
	    elseif(arg(1:3) .eq. '-sp' .or. arg(1:3) .eq. '-SP') then
	      l_SP = .true.       ! read external ascii SP file  
	   elseif(arg(1:3) .eq. '-p:') then
	      l_proc = .true.   
	      cstring = arg(4:len(arg))
	      read(cstring,*) filtfreq
	      print *,'freqfilt',filtfreq
         endif
      enddo

c      write(0,*) 'l_NIMS = ',l_NIMS
      if(l_asc) then
         if(l_NIMS) then
            write(6,*) '  Reading from ASCII NIMS data file'
         else
            write(6,*) '  Reading from generic ASCII data file'
         endif
         write(6,*)
         if(l_clk_hd) then
            write(6,*) '  Assuming clock reset information ',
     &                  'in data file headers'
            write(6,*)
            write(6,*)
         else
            write(6,*) '  Reading clock reset information from ',
     &                  '.clk file'
            write(6,*)
            write(6,*)
         endif
      else 
         if(l_NIMS) then
            write(6,*) '  Reading from NIMS binary data files'
         else
            write(6,*) '  Reading from binary data files'
!            write(6,
!     &         '(/,''   Using integer*'',i1,'' as binary input '',/)')
!     &         bytes
            write(6,*) '  KMS binary format '
         endif
      endif
      if (l_real) write(6,*) '  reading real numbers'

ccc   return here to start processing another data file
1000  continue

cTH   for testing to read ascii data
!	      l_asc_real = .false.    ! defaul read ascii/bin integer numbers
!            l_asc = .true.
!            l_clk_hd = .true.
!	      l_asc_real = .true.     ! read ascii real numbers


c*********************************************************************
      
c    compute l1 power spectrum for pre-scaling output
c          blank array pspecl1
      do i = 1,ndmx
         nspec(i) = 0
         do k = 1,nchmx
            do j = 1,nwmx
               pspecl1(k,j,i) = 0.0
            enddo
         enddo
      enddo


c*****  get station name from standard input, input files paths from
c       local file paths; open input file, make sp br etc path/file names
!      print *,'before cininit  nch=',nch
      call cininit(msval,rmsval,nch)
!      print *,'after cininit  nch=',nch
!      open(unit=46,file='junk.txt')
      if(ierr_bin_read .eq. -1) then
         write(6,*) 'Error Reading Binary File: ', err_file
         go to 500
      endif
      
      nchp1 = nch+1
!      print *,'increment  nch, nchp1',nch,nchp1
      call outinit(nch,lpack)



c  read system parameter file:  number of channels,
c  electrode line lengths, filter parameters, conversion
c  factors, etc. from file spsta###x
      if (l_SP) then
          call getsp(nch0,sampr,sc,nfil,iftype,afparam,
     &       decl,stcor,orient,chid,cda,cdb,lclkd)
          
      else
!         read system information from header      
          call getspkms(nch0,sampr,sc,nfil,iftype,afparam,
     &       decl,stcor,orient,chid,cda,cdb,lclkd)
      endif     
      nch_enable = nch0
      if (nch0 .eq. 6) then
          nch0 = 5
          nch_enable=6
      endif
      if(nch0.ne.nch) then
!      print *, 'nch0',nch0,'    nch',nch
         print*,'info: nch in sp file does not agree with nch in',
     &     ' data file'
 !        stop
          nch = nch0    !TH:  
!          print *, 'nch0',nch0,'    nch',nch
      endif
      nchp1=nch+1
      if(cfsp(4:11).eq.'standard') then
         print*,'Enter declination, station coordinates'
         read(5,*) decl,stcor(1),stcor(2)
      endif

c  set up decimation; decset reads parameters which control decimation
c  from a file; see documentation in decset for further info; 
      call decset(nwmx,lfd,idoff,ierr)
      if(ierr.eq.1) then
         print*,'parameters read from cf_decset are inconsistent',
     &   ' with parameters declared in main program'
           stop
      endif

c  compute sampling rate for each decimation level     
        nfusemx = 0
        do 1 i = 1,nd
        idl(i) = i + idoff
        samprate(i) = sampr
        nfusemx = max(nfusemx,nfuse(i))
           do 1 j = 1,i                        
c		print *,samprate(i)
1          samprate(i) = samprate(i)*idec(j)

c  set up decimation filter corrections, conversion of counts
c  to physical units (this routine makes a table of transfer
c  functions to correct for all of these)
      call fcorsu(samprate,nfil,afparam, !fc,nfc,nfcmx,nwin,nd,nch,
     1  iftype,sc,rnrmt,cda,lfd)
c    read in bad records file (gives record ranges which should not 
c    be processed (idp) or stacked (ids); see routine for input format
c    file also gives offset to adjust record numbers with
        call bdrcsu(nd,nbadmx,ndp,idp,nds,ids,ioff,samprate(1),
     &     time_int)
ccccEGBERT
ccc    Change call to mk_offset, and replace mk_offst.f with new version
ccc     declare dt (output by mk_offset, and used by phs_shft) as real
           call mk_offset(time_int,iset_offset,sampfreq,dt)
ccccEGBERT
      write(*,*) 'TIME_INTERVAL (sec)',time_int/1e6
!      write(*,*) 'set_offset',iset_offset        !TH: 

c    set up fft tables
      do 5 id = 1,nd
         call cffti(nwin(id),wsave(1,id),nsave(1,id))
5        continue

c  initialize various arrays
      do 6 i = 1,nd
6        lwinst(i) = .true.
      nuse = 0
      nmsmx = nwmx

c    get first block of data and set up pointers at start of processing
c    also, if too large a data gap occurs return to stmt. 90
c    and reset pointers

      lfirst = .true.
      if(l_asc) then
	    if (l_real) then
              call rdasc1(npts,x1,ierr,nch)     ! ascii real data
		else
              call rdasc(npts,ix1,ierr,nch)     ! ascii integer example data
		endif
      else
         if(l_NIMS) then
            call rdblkNIMSbin(npts,ix1,ierr,nch)
            write(6,*) 'rdblkNIMS ix1(0:5,1)', (ix1(kk,1),kk=1,6)
         else
!            call rdblk(npts,ix1,ierr,nch)        ! read binary data
            call rdblkKMS(npts,x1,ierr,nch_enable,nchmx1)    !,nch_enabled,irec)
         endif
      endif
      
      if (l_proc) then   ! filtering of powerline noise e.g. 60 Hz
          if (l_recfil) then
              call recfiltch(nchp1,npts,x1,filtfreq,
     &                       sampr,ierror_filt,nchmx1)
          else
! Bill test           call dftseg(nchp1,npts,x1,1000.,sampr,ierror_filt,nchmx1)
            call dftseg(nchp1,npts,x1,filtfreq,sampr,ierror_filt,nchmx1)
          endif  
          if (ierror_filt == 1) then
              l_proc = .false.
          else
              write(6,'(/,A9,F10.1,A)') 
     &     'FILTERING',filtfreq,' Hz powerline noise with all harmonics'
          endif
      else
          fNyq = 2./samr    
          if (filtfreq < 0.5/sampr) then
  !           print *,'CHECK, filtfreq, sampr',filtfreq,sampr
              write(6,'(/,A)') 
     & 'WARNING: no powerline noise (NOTCH filter) has been activated !'
              write(6,'(/,A)') 
     &    'if powerline noise is large, you could have problems'
         !     write(6,'(/,A)') 
  !   & 'stop by closing this window and apply notch filter, redo step 2'
              endif
      endif    
      
      if(ierr.eq.-1) go to 300
      lend = .false.
	
c90    irec1 = ix1(1,1)
90    irec1 = nint(x1(1,1))     !TH:

!	write(6,*) 'x1(1,1)',x1(1,1)        ! TH: test   x1(1,1)= first rec no.

      call pterst(irec1,ifirst,ifirstd,next,lstart,lstartd)
 
c>>>>>>>>>>>>>>>main loop starts here >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        ifrec = 0
100     continue
!        do iii=1,npts
!            write(46,'(6I10)') (nint(x1(k,iii)),k=1,6)
!        enddo    
        
cccc   TH: check
c	write(6,*) 'TH: check data at beginning'
c	  do idum=1,10
c	      write(6,*) (x1(k,idum),k=1,6)
c	  enddo

c     call decimation routine
	if (l_real) then
cTH     real ascii data
        call dcimtr(x1,npts,xx,nchp1,nmax,ifirst,ifirstd,next,       
     &     lstart,lstartd,nacc,rmsval,nchmx1)
	else
cTH     integer ascii data
        call dcimte(ix1,npts,xx,nchp1,nmax,ifirst,ifirstd,next,   
     &     lstart,lstartd,nacc,rmsval,nchmx1)
      endif
                           
      do 200 id = 1,nd
      if(nfuse(id).gt.0) then
c   compute number of sets accumulated at decimation level id
c    (will ususally be 1 or 0)
      nsets = (nacc(id) - olap(id) - 2*npwmx(id) - missmx(1,id)/2)
     &                           / ( nwin(id) - olap(id) )
      i_stop=0
         do 190 i = 1,nsets                                  
c          make set i at decimation level id; return in array x
           call mkset(xx,nchp1,nmax,ifirst,x,nwmx1,ist,id,irec,
     &         lrec,rmsval,lgood,roff,nchmx1)    ! nwmx changed 2 nwmx1
             istcount=ist
            ist = ist + iset_offset(id)
c   need to decide if set contains data segmenta which should not be
c   processed (declared in bad record file brsta###x)
           call badrec(nd,ndp,idp,id,irec,lrec,lg)
           if (lgood.and.lg) then
c       set is "good" (i.e. not too many missing data points; not
c       among the bad record ranges); proceed with processing

c   first difference,demean, window, and fourier transform data 
             n = nwin(id)
	       nmen=n+npwmx(id)-1
             call demean(x,nch,nmen,nchmx)
          call frstdif(x,nch,n,lfd,id,areg,npw(1,id),rr,ar,br,bwo,nchmx)
             call demean(x,nch,n,nchmx)
             call ps1win(x,nch,n,lwinst(id),w(1,id),nchmx)
             call fftnp2(n,nch,x,wrk,wsave(1,id),nsave(1,id),nchmx)

!      do ii=1,10
!          print *, 'spec    x', ii,x(1,ii),x(2,ii)
!      enddo

c   correct for filters (decimation, first differencing) and normalize
c   fourier coefficients to have units of nt/(sqrt(hz))
c   [ uses table of transfer function coefficients stored in complex
c     array rnrmt ]
        nfmid = nfuse(id)
        call filtcor(x,nch,nfmid,id,rnrmt,nd,areg,npw(1,id),n,lfd,
     &    nchmx,ndmx)
        nfreq = nfmid

ccccEGBERT
ccc ADD THIS CALL ... and include new subroutine phs_shft.f
cc      correct for offsets in actual sampling times
           call phs_shft(dt,x,nfreq,nch,samprate(id),nwin(id),nchmx)
ccccEGBERT

c        if necessary correct for clock drifts
              if(lclkd) then          
                 tset = ((irec+lrec)/2. - iclk0)*samprate(1)
                 call cldrft(x,nfreq,nch,samprate(id)
     &              ,nwin(id),cdb,tset,nchmx)
              endif

c     if necessary correct for offset of begining of set (caused by
c        non-integer set overlap)
              if(abs(roff) .gt. 1.0e-5) then
                 roff = - roff * samprate(1)
                 call cldrft(x,nfreq,nch,samprate(id)
     &              ,nwin(id),1.0,roff,nchmx)
              endif

c       check to see if set contains segments which should not be stacked
c       if so indicate by making set number negative
              call badrec(nd,nds,ids,id,irec,lrec,lg)
              if( .not. lgood) ist = - abs(ist)
ccc              if( .not. lg) ist = - abs(ist)
c              print*,'lg:', lg

c         output fourier coefficients to scratch file f_sta###x
              call freqout(nch,nfreq,x,ifrec,nsmax,nfusemx,
     &            x_scr,iuse_scr,nchmx)
c         add abs(FCs) to array to compute scalling factor for output
              call l1spec(nch,x,nfreq,pspecl1(1,1,id),nchmx)
              nspec(id) = nspec(id) + 1

c         update array ifdir (which will be used to sort out fourier coefficients
c         at end of program)
              nuse = nuse + 1
              ifdir(1,nuse) = id + idoff
              ifdir(2,nuse) = nfreq
              ifdir(3,nuse) = ist
c          print *,'ist,nuse,iset_offset,id,istcount',ist
c     &                   ,nuse,iset_offset(id),id,istcount

c     check for overflow of nsmax (maximum # of sets
              if (nuse.eq.nsmax) then
                 write(*,232) nsmax
 232   format(/,'!!!  Number of processed sets reached',/,
     &          '     maximum number of allowed sets !!!',/,
     &  	'     The program will finish processing now',/,
     &          '     To process all data change NSMAX =',i6,/,
     &          '     in file PARAMS1.INC !!!')
                 goto 300
              endif

ccc              print*, 'good',irec,lrec,id,ist
           else
              print*,'bad',lg,lgood,irec,lrec,id,ist
           endif
190     continue
        endif
200     continue
c    get more data and go back to top of main loop
      if(l_asc) then
ccc      slight complication here to get exactly the same results
ccc      with both ascii and binary.  With ASCII file EOF is detected
ccc      in rdasc after reading some data.  Set lend upon finding EOF,
ccc      use the data from the final read to make more sets, then
ccc      terminate.  With binary files EOF is not detected until
ccc      after the last data block has been read so this comlication
ccc      is not necessary
         if(lend) then
            goto 300
         else
			if(l_real) then
				call rdasc1(npts,x1,ierr,nch)
			else

				call rdasc(npts,ix1,ierr,nch)
			endif
            lend = (ierr .eq. -1)
            ierr = 0
         endif
      else
         if(l_NIMS) then
            if(lend) goto 300
            call rdblkNIMSbin(npts,ix1,ierr,nch)
            lend = (ierr .eq. -1)
            ierr = 0
         else
!            call rdblk(npts,ix1,ierr,nch)
            call rdblkKMS(npts,x1,ierr,nch_enable,nchmx1)    !,nch_enabled,irec)
         endif
      endif
      
      if (l_proc) then   ! filtering of powerline noise e.g. 60 Hz
!          call recfiltch(nchp1,npts,x1,filtfreq,sampr,ierror_filt,nchmx1)
!          call dftseg(nchp1,npts,x1,filtfreq,sampr,ierror_filt,nchmx1)
          If (l_recfil) then
              call recfiltch(nchp1,npts,x1,filtfreq,
     &                       sampr,ierror_filt,nchmx1)
          else
! Bill test            call dftseg(nchp1,npts,x1,1000.,sampr,ierror_filt,nchmx1)
            call dftseg(nchp1,npts,x1,filtfreq,sampr,ierror_filt,nchmx1)
          endif  
          
          if (ierror_filt == 1) then
              l_proc = .false.
          endif
      endif    
      
      if(npts .eq. 0) goto 300
                    
c     ierr = 0 for normal read
        if(ierr.eq.0) then
           lfirst = .false.
           go to 100
        endif
!        if(ierr .eq. -1 .and. npts .gt. 0) then    !TH:   last data points
!        if(ierr .eq. -1 .and. npts .gt. 0) then    !TH:   last data points
!            lfirst = .false.
!            goto 100
!        endif    

c      ierr = -3 when there is a gap in the record numbers that is so
c large that it is most reasonable to start the decimation filtering over
        if(ierr.eq. -3) then
           lfirst = .true.
           go to 90
        endif

c     ierr = -2 means the record numbers jump backwards; the program doesn't
c    know what to do about this and stops
        if(ierr.eq.-2) then
            print*,'error: excess records/ incorrect time mark'
            print*,'stopping here'
        endif
  
300     continue

c<<<<<<<<<<<<<<<<<<< end of main loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        print*
      print*,'number of sets = ',nuse
        print*

c***********************
c       reorder f_ file by frequency
c*************************

c       close connection to data file
      close(in_unit)
c       reorder and output file of fourier coefficients
c      l1 power spectrum  (only used when lpack = .true.)
      do 490 i = 1,nd
      do 490 j = 1,nch
      do 490 k = 1,nfuse(i)
         if(lpack) then
            pspecl1(j,k,i) = pspecl1(j,k,i)/nspec(i)
         else
            pspecl1(j,k,i) = 1.
         endif
490      continue

ccc   eliminate decimation levels with nfuse(id) = 0
      iid = 0
      do id = 1,nd
         if(nfuse(id) .gt. 0) then
            iid = iid + 1
            idl(iid) = idl(id)
            nwin(iid) = nwin(id)
            samprate(iid) = samprate(id)
         endif
      enddo

c      header for FC file
      if(lpack) then
         irlo = 4*(nch+1)
      else
         irlo = 4*(2*nch+1)
      end if
      

      call wfhead(nch,iid,nfusemx,nwin,samprate,idl
     1   ,chid,orient,decl,stcor,irlo)

c       read in scratch file, reorder pack if requested, output        
C     ME 	REMOVE SCRATCH FILE
c      call mkseq(ioscr,iouout,ifdir,iset,nuse,nch,nd,
c     1 cwrk,cout,nfusemx,idoff,pspecl1,nchmx,nwmx,lpack,iwrk,ixs)
      call mkseq(ifdir,iset,nuse,nch,nd,
     1 cwrk,cout,nfusemx,idoff,pspecl1,nchmx,nwmx,lpack,iwrk,ixs,
     2 nsmax, x_scr, iuse_scr)
C     ME 	REMOVE SCRATCH FILE        
c       close files; delete f_file on closing
      close(out_unit)
C ME 	REMOVE SCRATCH FILE
c      close(ioscr,status = 'delete')
C ME 	REMOVE SCRATCH FILE
500   continue

	

      if( .not. l_flinp) then
          write(0,'(''FT another data file?  '',$)')
          read(5,'(a1)') ans
          if(ans.eq.'y') go to 1000
      endif    
      deallocate(rnrmt)
      deallocate(cwrk)
      deallocate(cout)
      deallocate(x1)  
      deallocate(ix1)
      deallocate(iwrk)
      deallocate(iset)
      deallocate(ifdir)
      deallocate(ixs)
      deallocate(x_scr)
      stop
      end
