c
c************************************
c 
        subroutine demean(x,m,n,mdim)
        real x(mdim,n),xbar(25)
 
        do 5 j=1,m
        xbar(j)=0.0
        do 2 i=1,n
        xbar(j)=xbar(j)+x(j,i)
2       continue
        xbar(j)=xbar(j)/n
5       continue
 
        do 10 j=1,m
        do 10 i=1,n
        x(j,i)=x(j,i)-xbar(j)
10      continue
 
        return
        end


      REAL FUNCTION FJAC(J,I,NF,FREQ,DT)
!C
!C     calculate component of Jacobi Matrix
!C     parameter (1, cos w1, sin w1, cos w2, sin w2 ...)
!C
      DIMENSION FREQ(*)
      DATA PI2/6.283185307/


      JF = INT(J/2)
      IF (J .EQ. JF*2) THEN    ! even = cos
          FJAC = COS(PI2*FREQ(JF)*FLOAT(I-1)*DT)
      ELSE
          IF (J .EQ. 1) THEN   ! for mean value
              FJAC = 1.
          ELSE                 ! odd = sin
              FJAC = SIN(PI2*FREQ(JF)*FLOAT(I-1)*DT)
          ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE DFTSEG (NCHP1,NDAT,YDAT,FREQBASE,DT,ierror_filt,nchmx1)
      REAL YDAT(NCHMX1,*)
      
!.....executable statements
      ierror_filt = 0
      nfact = 6
      in_fsamp = int(1./dt + 0.5)
      if (in_fsamp == 4000) nfact = 3
      if (in_fsamp == 250) nfact = 12
      if (in_fsamp == 10000) nfact = 5
      if (in_fsamp >= 20000) nfact = 3
      
      samp_period = 1./DT/FREQBASE
!      print *,'samp_period',samp_period,dt,freqbase
!      print *,'ndat=npts=',ndat
            
      ns_inseg = NINT(samp_period*nfact)
!      ns_inseg = min0(ns_inseg,ndat)
      nseg = ndat/ns_inseg
!      print *,'ns_inseg,nseg,ndat',ns_inseg,nseg,ndat,nfact
      IF (samp_period .LE. 2 .OR. ns_inseg .GT. ndat ) THEN
        IF ( ndat .NE. 0) THEN
          write(6,*)
     &     'WARNING: no meaningful frequency to filter, skip filtering!'
            ierror_filt = 1
        ENDIF
        RETURN
      ENDIF    
      IF (nseg .LT. 1) THEN
          write(6,*) 
     &   'DFTSEG-WARNING: frequency too low, 
     &    nseg too large, skip filtering'
          ierror_filt = 1
          RETURN
      ENDIF   
      
      DO iseg=1,nseg-1
          NSTART = 1 + (iseg-1)*ns_inseg
          NFIT   = iseg*ns_inseg
          NSTOP  = NFIT
!          print *,'iseg,nstart,nfit,nstop',iseg,nstart,nfit,nstop
       call DFTOPT(NCHP1,NDAT,YDAT,NSTART,NFIT,NSTOP,FREQbase,DT,nchmx1)
      ENDDO   
!.....last segment
      NSTART = (nseg-1)*ns_inseg + 1
      NFIT   = nseg*ns_inseg
      NSTOP  = NDAT
      call DFTOPT(NCHP1,NDAT,YDAT,NSTART,NFIT,NSTOP,FREQbase,DT,nchmx1)
      RETURN
      END         

      SUBROUTINE DFTOPT(NCHP1,NDAT,YDAT,NSTART,NFIT,NSTOP,FREQBASE,DT,
     1                  nchmx1)
      IMPLICIT NONE
      SAVE
      REAL, INTENT(INOUT)    :: YDAT(NCHMX1,*)
      INTEGER, INTENT(IN)    :: NCHP1
      INTEGER, INTENT(IN)    :: NDAT
      INTEGER, INTENT(IN)    :: NSTART
      INTEGER, INTENT(IN)    :: NFIT
      INTEGER, INTENT(IN)    :: NSTOP
      REAL, INTENT(IN)       :: FREQBASE   
      REAL, INTENT(IN)       :: DT
      INTEGER, INTENT(IN)    :: NCHMX1
!      PARAMETER (NFMAX=1,NFA=2*NFMAX+1,MDIM=NFA*(NFA+1)/2)
      INTEGER, PARAMETER :: NFMAX = 28              ! # frequencies
      INTEGER, PARAMETER :: NFA   = 2*NFMAX + 1    ! # parameters, 1 for DC level
      INTEGER, PARAMETER :: MDIM  = NFA*(NFA+1)/2  ! dimension for Jacobi Matrix as vector 
      INTEGER            :: LDECOM = 0
      INTEGER            :: NF, I,J, K, MJAC, ISHIFT, N, M,ICH, KF
      INTEGER            :: LF, MP, IERROR
      REAL, EXTERNAL     :: FJAC
      REAL FREQ(NFMAX)
      REAL*8 AJAC(MDIM),XA(NFA)
      REAL*8 ARG,AN,AN1, A, B
      REAL*8 SUM
      REAL*8 CS1,CS2,SN1,SN2
      REAL*8 DPI2,DARG,DFREQ,CS,SN,S1,S2,SL,ALPHA
      DATA DPI2/6.283185307179586D0/
!      DATA LDECOM/0/
!C
!C.....set harmonic frequencies
      NF = INT(0.5/DT/FREQBASE)
!      write(6,*) 'nf,dt,freqbase',nf,dt,freqbase
      NF = MIN0(NF,NFMAX)
!      write(6,*) 'nf',nf
      DO I=1,NF
         FREQ(I) = FLOAT(I)*FREQBASE
      ENDDO
!      NF = 4
!      FREQ(1) = 19800
!      FREQ(2) = 21400
!      FREQ(3) = 22200
!      FREQ(4) = 24000
!      NF = 12
!      FREQ(1) = 60.
!      FREQ(2) = 30.9
!      FREQ(3) = 37.8
!      FREQ(4) = 82.2
!      FREQ(5) = 89.1
!      FREQ(6) = 120.
!      FREQ(7) = 180.
!      FREQ(8) = 240.
!      FREQ(9) = 300.
!      FREQ(10) = 360.
!      FREQ(11) = 420.
!      FREQ(12) = 480.
!      NF = 8
!      FREQ(1)= 49.9
!      FREQ(2)= 99.8
!      FREQ(3)= 149.7
!      FREQ(4)= 199.6
!      FREQ(5)= 249.6
!      FREQ(6) = 349.5
!      FREQ(7) = 449.3
!      FREQ(8) = 56.6

!C.....comput matrix only in first call
      ldecom = 0
      IF (LDECOM .EQ. 0) THEN
!C.........define the number of data points in a segment
	  N = NFIT - NSTART + 1
	  AN = DFLOAT(N)
	  AN1 = DFLOAT(N-1)

!C.........number of parameters
          M = 2*NF + 1
          ISHIFT = 1 ! beause of dc estimation
          MJAC = M*(M+1)/2
	IF (MJAC .GT. MDIM) PAUSE 'error in DFTOPT: too many parameters'
!C
!C.........set matrix and right side of normal equations to zero
          DO J=1,M
              DO k=1,J
                  SUM = 0.d0
                  DO I=NSTART,NFIT
                      SUM = SUM + 
     &                      FJAC(J,I,NF,FREQ,DT)*FJAC(K,I,NF,FREQ,DT)

                  ENDDO
                  AJAC((J-1)*J/2 + K) = SUM
!              write(6,*) 'A(j,k)',j,k,sngl(ajac((J-1)*J/2 + K))
              ENDDO
          ENDDO
      ENDIF
!C.....define the right side of normal equations with average + cos sin

!C.....loop over channels

      do ich=2,nchp1
      
!C.....the trigonometric sum for the right side by chebychef recursion
      DO 31 KF=1,NF
	  DFREQ = DBLE(FREQ(KF))

	  DARG = DPI2*DFREQ*DBLE(DT)
	  CS = DCOS(DARG)
	  SN = DSIN(DARG)
	  ALPHA = 2.D0*CS
	  S2 = 0.D0
          S1 = DBLE(YDAT(ich,NFIT))
	  DO 29 K=NFIT-1,NSTART+1,-1
              SL = DBLE(YDAT(ich,K)) + ALPHA*S1 - S2
	      S2 = S1
	      S1 = SL
   29     ENDDO
	  B = SN*S1
          A = DBLE(YDAT(ich,NSTART)) + 0.5D0*ALPHA*S1 - S2
	  LF = 2*KF + ISHIFT
	  XA(LF) = B            ! coeff. for sin(wt)
	  LF = LF - 1
	  XA(LF) = A            ! coeff. for cos(wt)
   31 ENDDO

      sum = 0.
      do i=nstart,nfit
        sum = sum + ydat(ich,i)
      enddo
      xa(1) = sum

!      do i=1,m
!         write(6,*) 'right side',ich,i,sngl(xa(i))
!      enddo

!C.....solve equation with cholesky decomposition
      CALL CHOSVEC(AJAC,M,MP,XA,IERROR,LDECOM)
      IF (IERROR .EQ. 1) THEN
	      PAUSE 'error in LOCKIN: matrix not positive definite'
	      stop 'program stop'
      ENDIF
!c      write(6,*) (sngl(xa(k)),k=1,m)
!     write(6,*) 'nstart,nfit,nstop',nstart,nfit,nstop
!C.....substract estimated harmonic oscilation from data
      DO 35 KF=1,NF
	  DFREQ = DBLE(FREQ(KF))

	  ARG = DPI2*DFREQ*DBLE(DT)
	  CS = DCOS(ARG)
	  SN = DSIN(ARG)
	  ALPHA = 2.D0*CS
	  CS2 = 1.0D0
	  CS1 = CS
	  SN2 = 0.0D0
	  SN1 = SN

	  LF = 2*KF + ISHIFT
	  B = XA(LF)             ! coeff. for sin(wt)
	  LF = LF - 1
	  A = XA(LF)             ! coeff. for cos(wt)

          YDAT(ich,NSTART) = YDAT(ich,NSTART) - SNGL(A)
          YDAT(ich,NSTART+1) = YDAT(ich,NSTART+1) - SNGL(A*CS + B*SN)
	      DO 33 I=NSTART+2,NSTOP
	          CS  = ALPHA*CS1 - CS2
	          CS2 = CS1
	          CS1 = CS
	          SN  = ALPHA*SN1 - SN2
	          SN2 = SN1
	          SN1 = SN
              YDAT(ich,I) = YDAT(ich,I) - SNGL(A*CS + B*SN)
   33     ENDDO
   35 ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE CHOSVEC(A,N,NDIM,X,IERROR,LDECOM)
!C
!C     solving linear equation with Cholesky decomposition
!C       A x = R  =  (L*L-t) x = R  =>  L w = R, (L-t) x = w
!C     the matrix must be symmetric and positive definit
!C     only the lower triangular part of the matrix is stored by row
!C     ******  INPUT  ******
!C     A......array of the lower part of the symmetric matrix
!C            the length of the array must be at least n*(n+1)/2
!C     N......dimension of the matrix, number of unknowns
!C     NDIM...dimension of the array at least n*(n+1)/2
!C     X......right side of the equation
!C     LDECOM...flag for decomposition
!C              0 = first call decomposition must be done
!C              else = decomposion is already done
!C              if several calls are done, put LDECOM in a DATA
!C              statement in calling routine, so parameter will
!C              be overwritten on output
!C     ******  OUTPUT  ******
!C     A......decomposed lower triangular matrix
!C     X......solution array of the equation, dimension N
!C     IERROR...flag: zero if o.k.,
!C                    one  if matrix is numerical not positive definit
!C                    square root of a negative number
!C     LDECOM...flag is set to 1 : decompostion was done
!C     ******  REMARKS  ******
!C     the lower part of the symmetric positive definite matrix
!C
!C         a11
!C         a21  a22
!C         a31  a32  a33
!C         a41  a42  a43  a44
!C
!C     is stored in an array by rows as follows:
!C
!C       ( a11  a21  a22  a31  a32  a33  a41  a42  a43  a44 )
!C
!C     transform matrix-indices to the array-index
!C         (i,j) =>  (i-1)*i/2 + j
!C
      SAVE
      REAL*8 A(*),X(*)
      REAL*8 XX
      IERROR = 0
!C.....decomposition
      IF (LDECOM .EQ. 0) THEN
	  IJ = 1
	  DO 15 I=1,N
	      KI = IJ
	      KJ = 1
	      DO 13 J=1,I
		  XX = A(IJ)
		  DO 11 K=KI,IJ-1
		      XX = XX - A(K)*A(KJ)
		      KJ = KJ + 1
   11             CONTINUE
		  IF (I .EQ. J) THEN
		      IF (XX .LE. 0.0) THEN
			  IERROR = 1
			  RETURN
		      ENDIF
		      A(IJ) = SQRT(XX)
		  ELSE
		      A(IJ) = XX/A(KJ)
		  ENDIF
		  KJ = KJ + 1
		  IJ = IJ + 1
   13         CONTINUE
   15     CONTINUE
	  LDECOM = 1
      ENDIF
!C.....forward substitution, solving L*w=x
      IJ = 0
      DO 23 I=1,N
	  DO 21 J=1,I-1
	      IJ = IJ + 1
	      X(I) = X(I) - A(IJ)*X(J)
   21     CONTINUE
	  IJ = IJ + 1
	  X(I) = X(I)/A(IJ)
   23 CONTINUE
!C.....backward substitution, solving L-transpose * x = w
      DO 27 I=N,1,-1
	  DO 25 J=I+1,N
	      JI = (j-1)*j/2 + i
	      X(I) = X(I) - A(JI)*X(J)
   25     CONTINUE
	  II = I*(I+1)/2
	  X(I) = X(I)/A(II)
   27 CONTINUE
      RETURN
      END
      
      SUBROUTINE RENOVA_CB(NCH,XINP,YOUT,FREQ,DT,ETA)
!.....forward recursive notch filter with time variant eta      
      IMPLICIT NONE
!.....definition statements    
      INTEGER, INTENT(IN)  :: NCH
      REAL, DIMENSION(NCH), INTENT(IN)     :: XINP
      REAL, DIMENSION(NCH), INTENT(OUT)    :: YOUT
      REAL, INTENT(IN)     :: FREQ
      REAL, INTENT(IN)     :: DT
      REAL, INTENT(INOUT)     :: ETA
!.....local variables      
      INTEGER, SAVE       :: ICOUNT,KMAX 
      REAL         :: E
      REAL*8,SAVE       :: PHI,CS,SN,A,AE,DE,FAKT,ETA1
      REAL*8,DIMENSION(5),SAVE       :: XX,X1,X2,YY,Y1,Y2
      REAL*8       :: PI2 = 0.628318530717958D+01
      REAL*8       :: PIHALF=.157079632679489D+01
      REAL*8       :: BOUND=0.1745329252D+00
      INTEGER      :: K
      DATA icount / 0/
!.....execution statements

      icount = icount + 1
      IF (ICOUNT == 1) THEN
          write(6,*) 'enter ETA for rekursive notch RENOVA ='
          READ (5,*) ETA
      
          write(6,*) 'recursive notch filter, eta =',eta
          PHI = PI2*DBLE(FREQ)*DBLE(DT)
          CS = DCOS(PHI)
          IF (DABS(PHI - PIHALF) .GT. BOUND) THEN
C.............compute mximum eta1 for critical damping
	       SN = DSIN(PHI)
	       ETA1 = SNGL((1.D0 + SN)/CS/CS)
	       KMAX = 2*INT(1./FREQ/DT)
          ELSE
C.............fixed values for phi near pi/2
	       ETA1 = 100.D0
	       KMAX = 10
          ENDIF
          A = 2.D0*CS
          DO K=1,NCH
              Y1(K) = 0.D0
              Y2(K) = Y1(K)
              X2(K) = DBLE(XINP(K))
              YOUT = 0.0
          ENDDO
      ELSEIF (ICOUNT == 2) THEN
          DO K=1,NCH
              X1(K) = DBLE(XINP(K))    
              YOUT(K) = 0.
          ENDDO
      ELSE
          E = ETA
          IF (ICOUNT .LE. KMAX) THEN
             E = -(ETA1-ETA)*(DFLOAT(ICOUNT-1)/DFLOAT(KMAX-1))**1 + ETA1
          ENDIF
          DE = DBLE(E)
          AE = A*DE
          FAKT = 1.D0/(E+E-1.D0)
          DO K=1,NCH
              XX(K) = DBLE(XINP(K))
              YY(K) = FAKT*(DE*XX(K) - AE*X1(K) 
     &              + DE*X2(K) + AE*Y1(K) - Y2(K))
              Y2(K) = Y1(K)
              Y1(K) = YY(K)
              X2(K) = X1(K)
              X1(K) = XX(K)
              YOUT(K) = YY(K)
          ENDDO
      ENDIF
      RETURN
      END SUBROUTINE RENOVA_CB
!      
      SUBROUTINE  recfiltch(nchp1,npts,x1,filtfreq, 
     &                       sampr,ierror_filt,nchmx1)
                            
!.....definition statements
      INTEGER, INTENT(IN)       :: nchp1
      INTEGER, INTENT(IN)       :: npts
      REAL,DIMENSION(nchmx1,npts), INTENT(INOUT)       :: x1
      REAL, INTENT(IN)          :: filtfreq
      REAL, INTENT(IN)         :: sampr
      INTEGER, INTENT(OUT)      :: ierror_filt
      INTEGER, INTENT(IN)       :: nchmx1
!.....local variables      
      INTEGER                  :: METHOD_FILT
      REAL, DIMENSION(5)       :: XINP,YOUT
      
      ierror_filt = 0
      eta = 1.02
 
      nch = nchp1 - 1
      method_filt = 1
      
      IF (filtfreq > 1./sampr) THEN
          ierror_filt = 1
          print *,'filtfreq, sampr',filtfreq,sampr
          WRITE(6,*) 
     &     'no meaningful filterfrequency, skip recursive filter'
          RETURN
      ENDIF
      DO I=1,NPTS
          DO K=1,NCH
              XINP(K) = X1(K+1,I)
          ENDDO
          IF (method_filt == 1) THEN
              CALL RENOVA_CB(NCH,XINP,YOUT,filtfreq,sampr,ETA)
          ELSEIF (method_filt == 2) THEN
              CALL DBdelay1_CB(NCH,XINP,YOUT,filtfreq,sampr,ETA)
          ELSE
              WRITE (6,*) 'method must be 1 or 2, skip filtering'
              ierror_filt = 1
              RETURN
          ENDIF
      ENDDO
 
      RETURN
      END SUBROUTINE recfiltch

      SUBROUTINE DBdelay2_CB(NCH,XINP,YOUT,FREQ,DT,ETA)
!.....forward recursive notch filter with time variant eta      
      IMPLICIT NONE
!.....definition statements    
      INTEGER, INTENT(IN)  :: NCH
      REAL, DIMENSION(NCH), INTENT(IN)     :: XINP
      REAL, DIMENSION(NCH), INTENT(OUT)    :: YOUT
      REAL, INTENT(IN)     :: FREQ
      REAL, INTENT(IN)     :: DT
      REAL, INTENT(IN)     :: ETA
!.....local variables      
      INTEGER, SAVE       :: ICOUNT,NC
      REAL*8, ALLOCATABLE, DIMENSION(:,:), SAVE       :: X_NC,Y_NC
      REAL*8,SAVE       :: FAKT
      REAL*8,SAVE       :: E,ETA1
      REAL*8       :: AL
      INTEGER      :: K,I,alloc_error
      DATA icount / 0/
!.....execution statements

      icount = icount + 1
      
      IF (icount == 1) THEN    !initialize
          NC=INT(0.5/FREQ/DT + 0.5)                   ! CALC DELAY Z**NC
          print *,'dely2 filter NC=',NC
          
          allocate (X_NC(1:NCH,1:NC),STAT=alloc_error)
          IF (alloc_error /= 0)  stop 'error in allocate x_nc'
          allocate (Y_NC(1:NCH,1:NC),STAT=alloc_error)
          IF (alloc_error /= 0)  stop 'error in allocate y_nc'
             
          
          ETA1 = 10.
!          NC1=N-NC
!.........set coefficients for time variant ETA
!          AL = ETA - ETA1
!	    K1 = 1
!	    K2 = 3*nc
!	    BL = ETA1
	    
	    E = ETA
	    FAKT = (1.D0+E)/2.D0/E
      ELSE IF(icount <= nc) THEN
!........initialize arrays
          DO K=1,NCH
              X_NC(K,icount) = DBLE(XINP(K))
              Y_NC(K,icount) = 0.D0
          ENDDO
      ELSE
          DO K=1,NCH
              DO I=1,NC-1   !shift data points 1 to left
                  X_NC(K,I) = X_NC(K,I+1)
              ENDDO
              X_NC(K,NC) = XINP(K)
              
              YOUT(K) = FAKT*XINP(K) + FAKT*X_NC(K,1) - Y_NC(K,1)/E
              
              DO I=1,NC-1   !shift data points 1 to left
                  Y_NC(K,I) = Y_NC(K,I+1)
              ENDDO
              Y_NC(K,NC) = YOUT(K)
              
          ENDDO
      ENDIF
      RETURN
      END SUBROUTINE DBdelay2_CB
      

      SUBROUTINE DBdelay1_CB(NCH,XINP,YOUT,FREQ,DT,ETA)
!.....forward recursive notch filter with time variant eta      
      IMPLICIT NONE
!.....definition statements    
      INTEGER, INTENT(IN)  :: NCH
      REAL, DIMENSION(NCH), INTENT(IN)     :: XINP
      REAL, DIMENSION(NCH), INTENT(OUT)    :: YOUT
      REAL, INTENT(IN)     :: FREQ
      REAL, INTENT(IN)     :: DT
      REAL, INTENT(IN)     :: ETA
!.....local variables      
      INTEGER, SAVE       :: ICOUNT,NC
      REAL*8, ALLOCATABLE, DIMENSION(:,:), SAVE       :: X_NC,Y_NC
      REAL*8,SAVE       :: FAKT
      REAL*8,SAVE       :: E,ETA1
      REAL*8       :: AL
      INTEGER      :: K,I,alloc_error
      DATA icount / 0/
!.....execution statements

      icount = icount + 1
      
      IF (icount == 1) THEN    !initialize
          write(6,*) 'enter ETA for delay type1 ='
          READ (5,*) ETA1
          
          NC=INT(1.0/FREQ/DT + 0.5)                   ! CALC DELAY Z**NC
          print *,'delay Type 1 (all mult) filter NC=',NC,'   eta=',eta
          
          allocate (X_NC(1:NCH,1:NC),STAT=alloc_error)
          IF (alloc_error /= 0)  stop 'error in allocate x_nc'
          allocate (Y_NC(1:NCH,1:NC),STAT=alloc_error)
          IF (alloc_error /= 0)  stop 'error in allocate y_nc'
             
          
          ETA1 = 10.
!          NC1=N-NC
!.........set coefficients for time variant ETA
!          AL = ETA - ETA1
!	    K1 = 1
!	    K2 = 3*nc
!	    BL = ETA1
	    
	    E = ETA1
	    FAKT = (1.D0+E)/2.D0/E
      ELSE IF(icount <= nc) THEN
!........initialize arrays
          DO K=1,NCH
              X_NC(K,icount) = DBLE(XINP(K))
              Y_NC(K,icount) = 0.D0
          ENDDO
      ELSE
          DO K=1,NCH
              DO I=1,NC-1   !shift data points 1 to left
                  X_NC(K,I) = X_NC(K,I+1)
              ENDDO
              X_NC(K,NC) = XINP(K)
              
              YOUT(K) = FAKT*XINP(K) - FAKT*X_NC(K,1) + Y_NC(K,1)/E
              
              DO I=1,NC-1   !shift data points 1 to left
                  Y_NC(K,I) = Y_NC(K,I+1)
              ENDDO
              Y_NC(K,NC) = YOUT(K)
              
          ENDDO
      ENDIF
      RETURN
      END SUBROUTINE DBdelay1_CB
            