      MODULE l_4byte_inc
 
!        LOGICAL, PARAMETER :: l_4byte = .true.  ! for Windows platform
!        logical, parameter :: l_4byte = .true. ! for Unix
        logical, parameter :: l_4byte = .true. ! for Windows (BRL)
!       set l_4byte = .true. !if FOrtran compiler assumes that record length for
!       direct access file connect is specified in four byte words (instead of
!       bytes)
      END MODULE l_4byte_inc
      
      MODULE nchmx_inc
!         FOR EMTF (dnff, tranmt, multmtrn)  ... sets max # of channels
!         to allow for
          INTEGER, PARAMETER :: nchmx = 5
      END MODULE nchmx_inc

      MODULE datsz_inc
!         FOR EMTF (dnff, tranmt, multmtrn) 
!         parameters to change for output file format
!........ number of data samples to put in one output record
          USE nchmx_inc
          INTEGER, PARAMETER     :: nt0 =  256 !256     !256 original which works
          INTEGER, PARAMETER     :: nblk = nt0
       END MODULE datsz_inc

      MODULE input_inc
!	include file input.inc
!	contains variables used in input routines
!
!	routines including input.inc:
!		dnff	(dnff.f)
!		cininit	(inpu_bin.f)
!		rdhd	(inpu_bin.f)
!		rdblk	(inpu_bin.f)
      IMPLICIT NONE
      SAVE
      
	INTEGER*8   :: time_int
	INTEGER     :: iclk0
	REAL        :: sampfreq
	REAL        :: dr
	LOGICAL     :: lfmiss
	LOGICAL     :: lfirst
	CHARACTER(LEN=80)  :: cfile, flnam             !TH: flnam
	CHARACTER(LEN=80)  :: err_file
	INTEGER     :: bytes
	INTEGER     :: itf
	INTEGER     :: ierr_bin_read
!
!     variables added for ASCII input data file 
      LOGICAL     :: l_flinp  ! = .true. for enter filename in command line 
	LOGICAL     :: l_asc    ! = .true. for ASCII data file
	LOGICAL     :: l_NIMS   ! = .true. for NIMS ASCII data file
      LOGICAL     :: l_clk_hd != .true. for clock reset info in file header
	LOGICAL     :: l_asc_rec_num  ! = .true. for sample numbers at beginning
!                     = .true. for sample numbers at beginning of each data record
!      common /inblk/  dr,iclk0,ioff,nmsmx,lfirst,lfmiss,cfile,time_int,  
!     &     sampfreq,bytes, itf, ierr_bin_read,err_file
!ccc     variables added for ASCII input data file 
!     &      , l_clk_hd,l_asc,l_asc_rec_num,l_NIMS

      END MODULE input_inc


      MODULE iounits_inc
!	include file IOUNITS.INC
!	
!	define all I/O units here to avoid opening files 
!	under the same unit. Set all units using PARMATER
!	statements.
!
!	This file is included in the folowing routines:
!		dnff
!		cininit		(inpu_bin.f)
!		rdhd		(inpu_bin.f)
!		rdblk		(inpu_bin.f)
!		decset
!		getsp
!		bdrscu
!		outinit		(out_pack.f)
!		resptbl
        IMPLICIT NONE
        SAVE

	    INTEGER, PARAMETER   :: br_unit  = 69      ! bad record file
	    INTEGER, PARAMETER   :: pw_unit  = 1
	    INTEGER, PARAMETER   :: dec_unit = 1
	    INTEGER, PARAMETER   :: in_unit  = 12
	    INTEGER, PARAMETER   :: out_unit = 15
	    INTEGER, PARAMETER   :: rsp_unit = 37
	    INTEGER, PARAMETER   :: sp_unit  = 55
	    INTEGER, PARAMETER   :: pth_unit = 77
	    INTEGER, PARAMETER   :: clk_unit = 76

          CHARACTER(LEN=80)    :: cfbr            ! bad record file
          CHARACTER(LEN=80)    :: cfdecset        ! decimation level definition file
          CHARACTER(LEN=80)    :: cfpwset         ! pre-whitening definition file
          CHARACTER(LEN=80)    :: cfout           ! FC output file
	    CHARACTER(LEN=80)	   :: cfsp		      ! System INTEGER, PARAMETER     :: file
	    CHARACTER(LEN=80)	   :: cfrsp
	    CHARACTER(LEN=80)    :: cfrsp_path      ! path for calibration files
	    CHARACTER(LEN=80)	   :: cfclk		      ! clock reset file (ASCII data files)
	    
	    LOGICAL        :: l_asc_FC=.false.      !TH: check Fourier coeff as ascii
c	    LOGICAL        :: l_asc_FC=.true.      !TH: check Fourier coeff as ascii
	    
!        common /FILES/  cfbr,cfdecset,cfpwset,cfout,cfsp, cfrsp, cfclk
      END MODULE iounits_inc
      
      
      
      MODULE params1_inc
!c      c	include file PARAMS1.INC
!c
!c	define all general INTEGER, PARAMETER     ::s for the processing. There are
!c	three more INTEGER, PARAMETER     ::s set in PARAMS2.INC
!c
!c	This include file is included by:
!c		dnff!
!
!c#####################################################################
!c       these INTEGER, PARAMETER     ::s may need to be changed if window lengths,
!c       number of decimation levels, decimation factors,
!c       filter corrections, length of time series etc. are changed!
!c	INTEGER, PARAMETER     ::S:
!c	
!c	NWMX: 	Maximum length of windows to be fft'd (in samples)
!c	NSMAX:	Maximum number of sets to allow for (this is the sum
!c		over all sets in all decimation levels)
!c	NBADMX: Maximum number of bad record segments
!c	NBYTES: storage format of binary time series
!c		depending on NBYTES the reclen is set and 
!c		RDBLK reads data into different arrays	
!c			NBYTES = 4: integer*4
!c			NBYTES = 2: integer*2
!c		the user can change the storage format using
!c		the command line option -b(2or4)
!c       LPACK:  logical INTEGER, PARAMETER     :: to control packing of FCs in
!c                output file.  If LPACK = .TRUE. each complex FC
!c                is packed into a 4 byte integer.

          IMPLICIT NONE
          SAVE

          INTEGER, PARAMETER     :: nwmx = 2048 !128    ! Maximum length of windows to be fft'd (in samples)
!                               TH orig: 400000     
	    INTEGER, PARAMETER     :: nsmax = 200000 ! Maximum number of sets to allow for (this is the sum
          INTEGER, PARAMETER     ::  nbadmx = 100
	    INTEGER, PARAMETER     ::  NBYTES = 2 	

          CHARACTER(LEN=3), PARAMETER     :: BINASC = 'BIN'
!         set BINASC = 'BIN' for binary files by default, = 'ASC' for ascii
celw          LOGICAL, PARAMETER   :: lpack = .false.
              LOGICAL, PARAMETER   :: lpack = .true.
c              LOGICAL, PARAMETER   :: lpack = .false.

      END MODULE params1_inc

      MODULE params2_inc
!
!       This mudule is used by DECIMATE_INC
!
!       PARAMETERS:
!
!       NDMX:   Maximum number of decimation levels
!       NCHMX:  Maximum number of channels to be fft'd
!       NFCMX:  Maximum number of filter coefficients for
!               decimation filter (should be about equal 
!               to the maximum decimation factor)
!       NFILMAX:  Maximum number of filters to correct for one data channel
        USE nchmx_inc
        IMPLICIT NONE
        SAVE 
        
        
        INTEGER, PARAMETER   :: ndmx    = 10
        INTEGER, PARAMETER   :: nfcmx   = 5
        INTEGER, PARAMETER   :: nfilmax = 4
      END MODULE params2_inc

      MODULE decimate_inc
!       includes variables used in decimation process and related subroutines
!       routines including decimate.inc:
!       dcimte.f
!       decset.f
!       dnff.f
!       fcorsu.f
!       mk_offst.f
!       mkset.f
!       pterst.f
	  USE  params2_inc
	  IMPLICIT NONE
	  SAVE

        INTEGER, DIMENSION(ndmx)          ::    nfc
        INTEGER, DIMENSION(ndmx)          ::    ioffr
        INTEGER, DIMENSION(ndmx)          ::    ioffs
        INTEGER, DIMENSION(ndmx)          ::    npwmx
        INTEGER, DIMENSION(2,ndmx)        ::    missmx
        INTEGER, DIMENSION(ndmx)          ::    idec
        INTEGER, DIMENSION(nchmx,ndmx)    ::    npw
        INTEGER, DIMENSION(ndmx)          ::    nfuse
        INTEGER, DIMENSION(ndmx)          ::    nwin
        INTEGER                           ::    nd != ndmx
        INTEGER                           ::    nch != nchmx
        
        REAL, DIMENSION(ndmx)             ::    olap
        REAL, DIMENSION(ndmx,nfcmx)       ::    fc           ! Fourier coeff
!       common /DECIMATE/ nfc, ioffr, ioffs, npwmx, missmx, idec, npw,
!    &                          nfuse, nwin, nd, nch, olap, fc   
      END MODULE decimate_inc


      MODULE fcor_inc
         IMPLICIT NONE
         SAVE
      
         INTEGER, PARAMETER   :: nfilmax = 4
         INTEGER, PARAMETER   :: nchmx = 20 
!        These parameters control table ... number of entries, spacing in log frequency
!        of table entries
         INTEGER, PARAMETER   :: nsystbl = 50
         REAL, PARAMETER      :: steplog = 1.25
      
      END MODULE fcor_inc
      
      MODULE FORMIN_common
      IMPLICIT NONE
      SAVE
      
      INTEGER   :: irec
      INTEGER   :: irecl
      
      END MODULE FORMIN_common
      
      
!     KMS modules follownchmx

      MODULE SD_param
      IMPLICIT NONE
      SAVE
  ! this module defines the parameter of SD-file definitions
  !    INTEGER, PARAMETER :: nbytes_page = 512         
  !    INTEGER, PARAMETER :: nbytes_header = nbytes_page*2
  !    INTEGER, PARAMETER :: nbytes_data   = 90*nbytes_page ! 46080 = 90 * 512
  !    INTEGER, PARAMETER :: nbytes_packet = nbytes_header + nbytes_data 
      INTEGER, PARAMETER   :: nbytes_page = 512   
      INTEGER              :: nbytes_data
      INTEGER              :: nbytes_header
      INTEGER              :: nbytes_packet
      REAL                 :: MagnetDecl             ! magnetic declination
!      INTEGER            :: nch = 5        
!      INTEGER            :: nsamples  != nbytes_data/nch/3  ! variable from channel, 3 bytes = 24 bit

      END MODULE SD_param
    
    
      MODULE SD_file_parameters_old            !  altes Module
       IMPLICIT NONE
       SAVE
!      parameters for header of SD file
       TYPE SD_header                                                ! byte offset
       SEQUENCE
          CHARACTER*1, DIMENSION(4) :: packet_starting_flag          ! 0000
          INTEGER*2                 :: packet_length                 ! 4
          INTEGER*2                 :: unused_1                      ! 6
          INTEGER*4                 :: KMS820_SN
          INTEGER*2                 :: KMS820_network_address
          INTEGER*2                 :: KMS820_network_address_mask
          INTEGER*4                 :: send_packet_ID
          INTEGER*4                 :: send_header_packet_ID
          INTEGER*4                 :: save_packet_ID
          INTEGER*2                 :: firmware_version
          INTEGER*2                 :: fpga_version
          CHARACTER(LEN=32)              :: GPS_pos_info
          CHARACTER(LEN=24)              :: GPS_time_info
          CHARACTER(LEN=8)               :: GPS_syn_clk
          INTEGER (KIND = 4)                 :: sampling_frequency
!          INTEGER (KIND = 8)                 :: first_sample_acq_time
          INTEGER (KIND = 4)                 :: first_sample_acq_time1
          INTEGER (KIND = 4)                 :: first_sample_acq_time2
          INTEGER*2                 :: sampling_time_read_frame_interval
          INTEGER*2                 :: AD_main_temperature
          INTEGER*2                 :: AD_SYS_I
          INTEGER*2                 :: AD_N11V
          INTEGER*2                 :: AD_P11V
          INTEGER*2                 :: AD_SYS_V
          INTEGER*4, DIMENSION(6)   :: sensor_SN
          INTEGER*1, DIMENSION(6)   :: sensor_ID
          INTEGER*1                 :: num_of_AD_page_send_queque_trigger_level
          INTEGER*1                 :: num_of_AD_page_save_queque_trigger_level
          INTEGER*2                 :: AD_send_available_RX_buffers
          INTEGER*2                 :: AD_save_available_512_pages
          CHARACTER*1, DIMENSION(8) :: status  ! contol bit
!          INTEGER*4               :: status1  ! contol bit
!          INTEGER*4               :: status2  ! contol bit
          CHARACTER*1, DIMENSION(8):: ch_setting   ! control bit sequence
!          INTEGER*4               :: ch_setting1  ! control bit sequence
!          INTEGER*4               :: ch_setting2  ! control bit sequence
          CHARACTER*1, DIMENSION(4):: AD_ctrl_word ! control bit sequence
          INTEGER*2, DIMENSION(6)   :: DA_offset_value
          INTEGER*2                 :: DA_CAL_value
          INTEGER*2                 :: DA_SENSOR_value
          CHARACTER*64              :: SD_file_name
          INTEGER*2                 :: SD_file_sector_size
          INTEGER*2                 :: SD_AD_data_sector_size_per_header
          INTEGER*4                 :: SD_file_limit_num
          INTEGER*4                 :: SD_file_index
          INTEGER*2                 :: SD_file_saved_sectors
          INTEGER*2                 :: SD_percent_freeSpace
          INTEGER*4                 :: SD_freeSpace
          
       END TYPE SD_header
       TYPE (SD_header)  :: SD_H_old
      END MODULE SD_file_parameters_old
   
    
      MODULE SD_file_parameters_kms1           !  neues Module
       IMPLICIT NONE
       SAVE
!      parameters for header of SD file
       TYPE SD_header                                                ! byte offset
       SEQUENCE
          CHARACTER*1, DIMENSION(4) :: packet_starting_flag          ! 0000
          INTEGER*2                 :: packet_length                 ! 4
          INTEGER*2                 :: unused_1                      ! 6
          CHARACTER(LEN=12) :: KMS820_SN
          INTEGER*2                 :: KMS820_network_address
          INTEGER*2                 :: KMS820_network_address_mask
          INTEGER*4                 :: send_packet_ID
          INTEGER*4                 :: send_header_packet_ID
          INTEGER*4                 :: save_packet_ID
          INTEGER*2                 :: firmware_version
          INTEGER*2                 :: fpga_version
          CHARACTER(LEN=32)              :: GPS_pos_info
          CHARACTER(LEN=24)              :: GPS_time_info
          CHARACTER(LEN=8)               :: GPS_syn_clk
          INTEGER (KIND = 4)                 :: sampling_frequency
!          INTEGER (KIND = 8)                 :: first_sample_acq_time
          INTEGER (KIND = 4)                 :: first_sample_acq_time1
          INTEGER (KIND = 4)                 :: first_sample_acq_time2
          INTEGER*2                 :: sampling_time_read_frame_interval
          INTEGER*2                 :: AD_main_temperature
          INTEGER*2                 :: AD_SYS_I
          INTEGER*2                 :: AD_N11V
          INTEGER*2                 :: AD_P11V
          INTEGER*2                 :: AD_SYS_V
          CHARACTER*12, DIMENSION(6)   :: sensor_SN
          CHARACTER*1, DIMENSION(6)    :: sensor_component
          CHARACTER*2                  :: unused_2
          INTEGER*2, DIMENSION(6)       :: sensor_orientation
          INTEGER*2, DIMENSION(6)       :: sensor_distance
          CHARACTER*1, DIMENSION(6)     :: sensor_ID
          INTEGER*1                 :: num_of_AD_page_send_queque_trigger_level
          INTEGER*1                 :: num_of_AD_page_save_queque_trigger_level
          INTEGER*2                 :: AD_send_available_RX_buffers
          INTEGER*2                 :: AD_save_available_512_pages
          CHARACTER*1, DIMENSION(8) :: status  ! contol bit
!          INTEGER*4               :: status1  ! contol bit
!          INTEGER*4               :: status2  ! contol bit
          CHARACTER*1, DIMENSION(8):: ch_setting   ! control bit sequence
!          INTEGER*4               :: ch_setting1  ! control bit sequence
!          INTEGER*4               :: ch_setting2  ! control bit sequence
          CHARACTER*1, DIMENSION(4):: AD_ctrl_word ! control bit sequence
          INTEGER*2, DIMENSION(6)   :: DA_offset_value
          INTEGER*2                 :: DA_CAL_value
          INTEGER*2                 :: DA_SENSOR_value
          CHARACTER*64              :: SD_file_name
          INTEGER*2                 :: SD_file_sector_size
          INTEGER*2                 :: SD_AD_data_sector_size_per_header
          INTEGER*4                 :: SD_file_limit_num
          INTEGER*4                 :: SD_file_index
          INTEGER*2                 :: SD_file_saved_sectors
          INTEGER*2                 :: SD_percent_freeSpace
          INTEGER*4                 :: SD_freeSpace
          CHARACTER(LEN=128)        :: user_comments
          
       END TYPE SD_header
       TYPE (SD_header)  :: SD_H_kms1  ! 
      END MODULE SD_file_parameters_kms1
   
    
      MODULE SD_file_parameters           !  new Module kms2 definition
       IMPLICIT NONE
       SAVE
!      parameters for header of SD file
       TYPE SD_header                                                ! byte offset
       SEQUENCE
          CHARACTER*1, DIMENSION(4) :: packet_starting_flag          ! 0000
          INTEGER*2                 :: packet_length                 ! 4
          INTEGER*2                 :: host_WI_network_address       ! 6
          CHARACTER(LEN=16) :: KMS820_SN
          INTEGER*2                 :: KMS820_network_address
          INTEGER*2                 :: KMS820_network_address_mask
          INTEGER*4                 :: send_packet_ID
          INTEGER*4                 :: send_header_packet_ID
          INTEGER*4                 :: save_packet_ID
          CHARACTER(LEN=1)          :: network_mode
          CHARACTER(LEN=1)          :: firmware_version
          CHARACTER(LEN=1)          :: unsused_char3
          CHARACTER(LEN=1)          :: fpga_version
          CHARACTER(LEN=32)              :: GPS_pos_info
          CHARACTER(LEN=24)              :: GPS_time_info
          CHARACTER(LEN=8)               :: GPS_syn_clk
          INTEGER (KIND = 4)                 :: sampling_frequency
          INTEGER (KIND = 8)                 :: first_sample_acq_time
!          INTEGER (KIND = 4)                 :: first_sample_acq_time1
!          INTEGER (KIND = 4)                 :: first_sample_acq_time2
          INTEGER*2                 :: sampling_time_read_frame_interval
          INTEGER*2                 :: AD_main_temperature
          INTEGER*2                 :: AD_SYS_I
          INTEGER*2                 :: AD_N11V
          INTEGER*2                 :: AD_P11V
          INTEGER*2                 :: AD_SYS_V
          CHARACTER*16, DIMENSION(6)   :: sensor_SN
          CHARACTER*1, DIMENSION(6)    :: sensor_component
          CHARACTER*1                  :: wireless_signal_strength
          CHARACTER*1                  :: unused_2
          INTEGER*2, DIMENSION(6)       :: sensor_orientation
          INTEGER*2, DIMENSION(6)       :: sensor_distance
          CHARACTER*1, DIMENSION(6)     :: sensor_ID
          INTEGER*1                 :: num_of_AD_page_send_queque_trigger_level
          INTEGER*1                 :: num_of_AD_page_save_queque_trigger_level
 !         INTEGER*2                 :: AD_send_available_RX_buffers
 !         INTEGER*2                 :: AD_save_available_512_pages  ! herausgenommen v8 
          INTEGER*4                 :: num_of_data_bytes_per_headers
          CHARACTER*1, DIMENSION(8) :: status  ! contol bit
!          INTEGER*4               :: status1  ! contol bit
!          INTEGER*4               :: status2  ! contol bit
          CHARACTER*1, DIMENSION(8):: ch_setting   ! control bit sequence
!          INTEGER*4               :: ch_setting1  ! control bit sequence
!          INTEGER*4               :: ch_setting2  ! control bit sequence
          CHARACTER*1, DIMENSION(4):: AD_ctrl_word ! control bit sequence
          INTEGER*2, DIMENSION(6)   :: DA_offset_value
          INTEGER*2                 :: DA_CAL_value
          INTEGER*2                 :: DA_SENSOR_value
          CHARACTER*64              :: SD_file_name
          INTEGER*2                 :: SD_file_sector_size
          INTEGER*2                 :: SD_AD_data_sector_size_per_header
          INTEGER*4                 :: SD_file_limit_num
          INTEGER*4                 :: SD_file_index
          INTEGER*2                 :: SD_file_saved_sectors
          INTEGER*2                 :: SD_percent_freeSpace
          INTEGER*4                 :: SD_freeSpace
          INTEGER*2, DIMENSION(4,3,6) :: igain_tab
          CHARACTER(LEN=128)        :: user_comments
          
       END TYPE SD_header
       TYPE (SD_header)  :: SD_H
      END MODULE SD_file_parameters   
      
